// Declare Global variables
 extern int fastSMA_Period = 14;
 extern int slowSMA_Period = 50;
 extern double lotSize = 0.04;
 extern int profitTarget1 = 50;
 int magicNumberBuy = 1111;
 int magicNumberSell = 2222;
 int maxSellPositions = 1;
 int buyStopOrderTickets[];
 

//Sell positions counter function  
   int MySellCount()
  
  {
  int sellCount = 0;
  string symbol =  OrderSymbol();
  for (int i = OrdersTotal()-1; i >= 0; i--)
  
  if (OrderSelect(i,SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == symbol && OrderType() == OP_SELL)
  
  sellCount++;
    
    if (sellCount < maxSellPositions)
    return True;
         
         else
         
             return False;
    }
    
// Fuunction to check for a new candle
 bool IsNewCandleSell()
   {
   static int BarsOnChart = Bars;
    if(Bars == BarsOnChart)
      return (false);
      BarsOnChart = Bars;
         return(true);
   
   }   


// Function to place buy stop orders based on open sell trade
void placeBuyStopOrders() {
    // Define parameters
    double initialDistance = 20;  // Initial distance from sell trade to start buystoporders (in pips)
    int numOrders = 5;           // Number of stop orders
    double buyStopLotSize = 0.02;        // Buy stop orders lot size
    double distanceBetweenOrders = 15;  // Distance between stop orders (in pips)
    double stopLoss = 25;         // Stop loss for each buy stop order (in pips)

    // Counter to limit buy stop orders per sell trade
    int buyStopCounter = 0;

    // Check for open sell trades
    if (OrdersTotal() > 0) {
        for (int i = OrdersTotal() - 1; i >= 0; i--) {
            if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol() && OrderType() == OP_SELL) {
                // Calculate buy stop order levels
                double sellPrice = OrderOpenPrice();
                double initialLevel = sellPrice + initialDistance * Point;

                // Place buy stop orders with stop loss
                for (int j = 0; j < numOrders && buyStopCounter < numOrders; j++, buyStopCounter++) {
                    double buyStopPrice = initialLevel + j * distanceBetweenOrders * Point;
                    int ticket = OrderSend(OrderSymbol(), OP_BUYSTOP, buyStopLotSize, buyStopPrice, 3, buyStopPrice - stopLoss * Point, 0,  "Buy Stop Order", 0, 0, Green);
                }
            }
        }
    }
}

//function to manage buy stop orders
// Define global variables to store information
int sellOrderTicket = 0;
double gridDistance = 20.0; // in pips

// Function to check if a sell order is still open
bool IsSellOrderOpen() {
    int totalOrders = OrdersHistoryTotal();
    for (int i = totalOrders - 1; i >= 0; i--) {
        if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) && OrderType() == OP_SELL && OrderSymbol() == Symbol()) {
            return true; // Found an open sell order
        }
    }
    return false; // No open sell order found
}

// Function to check if any buy stop order has become a buy order and closed at stop loss
bool IsBuyStopOrderClosed(int ticket) {
    if (OrderSelect(ticket, SELECT_BY_TICKET) && OrderType() == OP_BUY && OrderSymbol() == Symbol() && OrderClosePrice() > 0) {
        return true;
    }
    return false;
}

// Function to replace a closed buy trade with a buy stop order
void ReplaceBuyStopOrder(int buyOrderTicket) {
    // Retrieve entry price and stop loss from the closed buy order
    double entryPrice = OrderOpenPrice();
    double stopLoss = OrderStopLoss();

    // Delete the closed buy order
    OrderDelete(buyOrderTicket);

    // Place a new buy stop order with the same entry price and stop loss
    int newTicket = OrderSend(Symbol(), OP_BUYSTOP, 1.0, entryPrice, 3, stopLoss, 0, "Buy Stop Order", 0, 0, Green);

    // Store the new buy stop order ticket dynamically
    for (int i = 0; i < ArraySize(buyStopOrderTickets); i++) {
        if (buyStopOrderTickets[i] == buyOrderTicket) {
            buyStopOrderTickets[i] = newTicket;
            break;
        }
    }
}



// Function to manage buy stop orders based on the originating sell trade
void ManageBuyStopOrders() {
    // Check if the originating sell order is still open
    if (IsSellOrderOpen()) {
        // Check if any buy stop order has become a buy order and closed at stop loss
        for (int i = 0; i < ArraySize(buyStopOrderTickets); i++) {
            if (IsBuyStopOrderClosed(buyStopOrderTickets[i])) {
                // Replace the closed buy trade with a new buy stop order
                ReplaceBuyStopOrder(buyStopOrderTickets[i]);
            }
        }

        // Call the function recursively for continuous monitoring
        ManageBuyStopOrders();
    } else {
        // Close buy orders and delete buy stop orders when the originating sell trade is closed
        {
            if (OrderSelect(buyStopOrderTickets[i], SELECT_BY_TICKET) && OrderType() == OP_BUYSTOP) {
                OrderDelete(buyStopOrderTickets[i]);
            }
        }
    }
}



//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
// Event Handling function below
//+------------------------------------------------------------------+
void OnTick()

   // Trading logic indicators, parameters and functions
{
   // Initialize variables
   double fastSMA_previous = iMA(_Symbol, _Period, fastSMA_Period, 0, MODE_SMA, PRICE_CLOSE, 2);
   double slowSMA_previous = iMA(_Symbol, _Period, slowSMA_Period, 0, MODE_SMA, PRICE_CLOSE, 2);
   double fastSMA_current = iMA(_Symbol, _Period, fastSMA_Period, 0, MODE_SMA, PRICE_CLOSE, 1);
   double slowSMA_current = iMA(_Symbol, _Period, slowSMA_Period, 0, MODE_SMA, PRICE_CLOSE, 1);
      
   {
        
   // Define your trading condition (e.g., SMA crossover)
   bool sellCondition = (fastSMA_previous > slowSMA_previous && fastSMA_current < slowSMA_current && MySellCount());
   // Check trading conditions
   
      if (IsNewCandleSell()&&(sellCondition))
   
      // Execute your trading logic (e.g., place a sell order)
      int ticket = OrderSend(_Symbol, OP_SELL, lotSize, Bid, 30, 0, (Bid - profitTarget1*_Point),"Sell Order", magicNumberSell, 0, clrRed);
     
     if (ticket > 0)
     
     // Place buystop orders 
     
     placeBuyStopOrders();
     
     ManageBuyStopOrders(); 
  }
}
     //THE END 